{% comment %}
    This include helps to easily embed pie/bar charts in pages.

    To embed a chart, call it like this: (with Liquid percent tags around it)
    It MUST be valid Javascript, otherwise the chart will fail to display.

        include charts/pie.html data="
            labels: ['Democrat Counties', 'Republican Counties'],
            datasets: [{
                data: [94.7, 5.3],
                backgroundColor: ['rgb(24, 132, 205)', 'rgb(225, 69, 102)'],
            }],
        "

    For bar charts, there's a simple mode or Chart.js mode:

        include charts/bar.html data="
            simple: [
                [1988, [2292],  'red']
                [1992, [1514],  'blue']
                [1996, [1524],  'blue']
                [2000, [2438],  'red']
                [2004, [2527],  'red']
                [2008, [873],   'blue']
                [2012, [694],   'blue']
                [2016, [2623],  'red']
                [2020, [537],   'blue']
            ],
        "

        include charts/bar.html data="
            labels: ['Democrat Counties', 'Republican Counties'],
            datasets: [{
                label: 'X',
                data: [94.7, 5.3],
                backgroundColor: ['rgb(24, 132, 205)', 'rgb(225, 69, 102)'],
            }],
        "

    To label an axis, pass in:

        options="scales: {x: {title: {text: 'Dollars donated', display: true}}}"

    To add dollar signs to x-axis labels:

        options="dollars: true"
    
    To set the width, you need to ........ (TBC)

{% endcomment %}


{% if numChartsOnPage %}
    {% assign numChartsOnPage = numChartsOnPage | plus: 1 %}
{% else %}
    {% assign numChartsOnPage = 1 %}
{% endif %}

<div class="chart" style="position: relative; {% if include.width %}width: {{ include.width }}{% endif %}; {% if include.height %}height: {{ include.height }}{% endif %}; max-width: 100%">
  <canvas id="chart{{ numChartsOnPage }}"></canvas>
</div>

{% include chart.js %}

<script>
    var chartSettings = {
        type: '{{ include.type }}',
        data: { {{ include.data }} },
        options: {
            plugins: {
                legend: { 
                    position: 'bottom',
                    // maxWidth: 100,
                },
            },
            {{ include.options }}
        },
    };

    // Convert simple data structure (which I prefer) to proper Chart.js format
    if (chartSettings.data.simple) {

        // Disable legend
        chartSettings.options.plugins.legend.display = false;

        var data = chartSettings.data;
        data.labels = [];
        data.datasets = [];
        data.simple.forEach((item, i) => {
            var label = item[0];
            var values = item[1];
            var colors = Array.isArray(item[2]) ? item[2] : [item[2]]; // cast to an array if string

            data.labels.push(label);

            // Create the datasets, one for each set of values
            if (i == 0) {
                values.forEach((value, j) => data.datasets[j] = { data: [value] });
                colors.forEach((color, j) => data.datasets[j].backgroundColor = [color]);
            } else {
                values.forEach((value, j) => data.datasets[j].data.push(value));
                colors.forEach((color, j) => data.datasets[j].backgroundColor.push(color));
            }


        });
        // data.labels = data.simple.map(item => item[0]);
        // data.datasets = data.simple[0][1].map((x, i) => {
        //     // For each series, create an array of values and colors
        //     return {
        //         data: data.simple.map(item => item[1][i]),
        //         backgroundColor: typeof data.simple[0][2] == 'string'
        //             ? data.simple.map(item => item[2]),
        //             : data.simple.map(item => item[2]),
        //     };
        // });
    }


    // Replace color labels with actual nicer colours
    chartSettings.data.datasets.forEach(set => {
        if (!set.backgroundColor)
            return;
            
        var rawBackgroundColor = set.backgroundColor;
        set.backgroundColor = function(context) {

            if (!context.chart.chartArea)
                return;

            return rawBackgroundColor.map((color, i) => {
                if (color == 'light-red')
                    return createLinearGradient(context, '#ffece9');
                if (color == 'light-blue')
                    return createLinearGradient(context, '#ddeaff');
                if (color == 'red')
                    // return 'rgb(225, 69, 102)';
                    return createLinearGradient(context, 'rgb(225, 69, 102)');
                if (color == 'blue')
                    return createLinearGradient(context, 'rgb(24, 132, 205)');
                if (color == 'green')
                    return createLinearGradient(context, '#9ac046');
                if (color == 'orange')
                    return createLinearGradient(context, '#ffa544');
                
                // Otherwise, just show the plain color
                return color;
            });
        };
    });

    // Put dollar signs on the axis if dollars:true
    if (chartSettings.options.dollars) {
        chartSettings.options.scales = chartSettings.options.scales || {};
        chartSettings.options.scales.x = chartSettings.options.scales.x || {};
        chartSettings.options.scales.x.ticks = {
            // Include a dollar sign in the ticks
            callback: function(value, index, values) {
                // console.log('callback called');
                return '$' + value.toLocaleString([], {}); //.toFixed(0);
            }
        };
    }

    // console.log(chartSettings);
    // Todo, hide legend for bar charts with only 1 series?

    // Generate chart (with a unique ID for each one on page)
    window.chart{{ numChartsOnPage }} = new Chart(
        document.getElementById('chart{{ numChartsOnPage }}'), 
        chartSettings
    );


    //----- Helper Functions -----

    /**
     * Canvas function. Creates a linear gradient for the chart.
     */
    function createLinearGradient(context, color1) {

        // Convert color1 to rgb() format if it's in hex form
        if (color1.charAt(0) == '#') {
            color1 = 'rgb('
                + parseInt(color1.substr(1,2), 16) + ','
                + parseInt(color1.substr(3,2), 16) + ','
                + parseInt(color1.substr(5,2), 16)
                + ')';
        }

        // For color2, we'll darken color1 by half
        color2 = color1.replace(/\d+/g, value => Math.round(value * 0.83));

        //console.log('Color', color1, color2);

        //console.log('Starting bgcolor', {{ numChartsOnPage }});
        var chartIsHorizontal = chartSettings.options.indexAxis == 'y';

        // createLinearGradient(x0,y0,x1,y1);
        if (chartIsHorizontal)
            var gradient = context.chart.ctx.createLinearGradient(
                context.chart.chartArea.right, 0, context.chart.chartArea.left, 0
            );
        else
            var gradient = context.chart.ctx.createLinearGradient(
                0, context.chart.chartArea.bottom, 0, context.chart.chartArea.top
            );

        gradient.addColorStop(0.5, color1);
        gradient.addColorStop(0, color2);
        return gradient;
    }

</script>